"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var clear = require("clear");
var chalk = require("chalk");
var figlet = require("figlet");
var program = require("commander");
var package_json_1 = require("../../package.json");
var listenCtrlC_1 = require("./utils/listenCtrlC");
var demo_1 = require("./commands/demo");
var file_1 = require("./commands/file");
var help_1 = require("./commands/help");
function startApp() {
    program
        .version(package_json_1.version)
        .description(package_json_1.description)
        .option('-f, --file <type>', 'To attach a configuration file')
        .option('-r, --restart', 'To restart the paused campaign')
        .option('support', 'To get help')
        .option('demo', 'To get a sample configuration file with themes and CSV')
        .parse(process.argv);
    clear();
    console.log(chalk.yellow.bold(figlet.textSync('bmc-v2', {
        horizontalLayout: 'full',
        font: 'Swan',
    })));
    console.log("Type " + chalk.cyan('bulkmail support') + " for support.");
    if (program.demo)
        demo_1.default();
    if (program.support)
        help_1.default();
    if (program.file)
        file_1.default(program.file, program.restart);
    listenCtrlC_1.default();
    process.exitCode = 0;
}
exports.default = startApp;
//# sourceMappingURL=start.js.map