"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var nodemailer = require("nodemailer");
var socks = require("socks");
var stringProcessor_1 = require("./stringProcessor");
function createTransport(configData) {
    var _a = configData.credentials, host = _a.host, port = _a.port, secureConnection = _a.secureConnection, email = _a.email, password = _a.password, proxy = _a.proxy;
    var smtpOptions = {
        host: stringProcessor_1.default(host, process.env),
        port: parseInt(stringProcessor_1.default(port.toString(), process.env)),
        secure: stringProcessor_1.default(secureConnection.toString(), process.env) == 'true',
        auth: {
            user: stringProcessor_1.default(email, process.env),
            pass: stringProcessor_1.default(password, process.env),
        },
        tls: {
            rejectUnauthorized: false,
        },
        proxy: proxy ? stringProcessor_1.default(proxy, process.env) : null,
    };
    var transporter = nodemailer.createTransport(smtpOptions);
    transporter.set('proxy_socks_module', socks);
    return transporter;
}
exports.default = createTransport;
//# sourceMappingURL=createTransport.js.map